# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule MailSlurpAPI.Api.MailServerController do
  @moduledoc """
  API calls for all endpoints tagged `MailServerController`.
  """

  alias MailSlurpAPI.Connection
  import MailSlurpAPI.RequestBuilder


  @doc """
  Get DNS Mail Server records for a domain

  ## Parameters

  - connection (MailSlurpAPI.Connection): Connection to server
  - describe_options (DescribeDomainOptions): describeOptions
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, %MailSlurpAPI.Model.DescribeMailServerDomainResult{}} on success
  {:error, info} on failure
  """
  @spec describe_mail_server_domain(Tesla.Env.client, MailSlurpAPI.Model.DescribeDomainOptions.t, keyword()) :: {:ok, MailSlurpAPI.Model.DescribeMailServerDomainResult.t} | {:error, Tesla.Env.t}
  def describe_mail_server_domain(connection, describe_options, _opts \\ []) do
    %{}
    |> method(:post)
    |> url("/mail-server/describe/domain")
    |> add_param(:body, :body, describe_options)
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %MailSlurpAPI.Model.DescribeMailServerDomainResult{}},
      { 201, false},
      { 401, false},
      { 403, false},
      { 404, false}
    ])
  end

  @doc """
  Lookup DNS records for a domain

  ## Parameters

  - connection (MailSlurpAPI.Connection): Connection to server
  - dns_lookup_options (DnsLookupOptions): dnsLookupOptions
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, %MailSlurpAPI.Model.DnsLookupResults{}} on success
  {:error, info} on failure
  """
  @spec get_dns_lookup(Tesla.Env.client, MailSlurpAPI.Model.DnsLookupOptions.t, keyword()) :: {:ok, MailSlurpAPI.Model.DnsLookupResults.t} | {:error, Tesla.Env.t}
  def get_dns_lookup(connection, dns_lookup_options, _opts \\ []) do
    %{}
    |> method(:post)
    |> url("/mail-server/describe/dns-lookup")
    |> add_param(:body, :body, dns_lookup_options)
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %MailSlurpAPI.Model.DnsLookupResults{}},
      { 201, false},
      { 401, false},
      { 403, false},
      { 404, false}
    ])
  end

  @doc """
  Get IP address for a domain

  ## Parameters

  - connection (MailSlurpAPI.Connection): Connection to server
  - name (String.t): name
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, %MailSlurpAPI.Model.IpAddressResult{}} on success
  {:error, info} on failure
  """
  @spec get_ip_address(Tesla.Env.client, String.t, keyword()) :: {:ok, MailSlurpAPI.Model.IpAddressResult.t} | {:error, Tesla.Env.t}
  def get_ip_address(connection, name, _opts \\ []) do
    %{}
    |> method(:post)
    |> url("/mail-server/describe/ip-address")
    |> add_param(:query, :"name", name)
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %MailSlurpAPI.Model.IpAddressResult{}},
      { 201, false},
      { 401, false},
      { 403, false},
      { 404, false}
    ])
  end

  @doc """
  Verify the existence of an email address at a given mail server.

  ## Parameters

  - connection (MailSlurpAPI.Connection): Connection to server
  - verify_options (VerifyEmailAddressOptions): verifyOptions
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, %MailSlurpAPI.Model.EmailVerificationResult{}} on success
  {:error, info} on failure
  """
  @spec verify_email_address(Tesla.Env.client, MailSlurpAPI.Model.VerifyEmailAddressOptions.t, keyword()) :: {:ok, MailSlurpAPI.Model.EmailVerificationResult.t} | {:error, Tesla.Env.t}
  def verify_email_address(connection, verify_options, _opts \\ []) do
    %{}
    |> method(:post)
    |> url("/mail-server/verify/email-address")
    |> add_param(:body, :body, verify_options)
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %MailSlurpAPI.Model.EmailVerificationResult{}},
      { 201, false},
      { 401, false},
      { 403, false},
      { 404, false}
    ])
  end
end
